## oregano 0.84.40+dfsg.1

=== wscript ===
#! /usr/bin/env python3
# encoding: utf-8

VERSION = '0.84.40'
APPNAME = 'oregano'

top = '.'
out = 'build'

import os
from waflib import Logs as logs
from waflib import Utils as utils

rec = ['src', 'po', 'data', 'test']

def options(opt):
	opt.load('compiler_c gnu_dirs glib2')

	opt.add_option('--debug', dest='build_debug', action='store_true', default=False, help='Build with debug flags')
	opt.add_option('--release', dest='build_release', action='store_true', default=False, help='Build with release flags')
	opt.add_option('--no-install-gschema', dest='no_install_gschema', action='store_true', default=False, help='Do not install the schema file')
	opt.add_option('--no-xdg', dest='no_xdg', action='store_true', default=False, help='Do not install the xdg desktop or xdg mime files')
	opt.add_option('--run', action='store_true', default=False, help='Run imediatly if the build succeeds.')
	opt.add_option('--gnomelike', action='store_true', default=False, help='Determines if gnome shemas and gnome iconcache should be installed.')
#	opt.add_option('--intl', action='store_true', default=False, help='Use intltool-merge to extract messages.')


def configure(conf):
	conf.load('compiler_c gnu_dirs glib2 intltool')

	conf.env.appname = APPNAME
	conf.env.version = VERSION

	conf.define('VERSION', VERSION)
	conf.define('GETTEXT_PACKAGE', APPNAME)


	#things the applications needs to know about, for easier re-use in subdir wscript(s)
	conf.env.path_datadir =  utils.subst_vars('${DATADIR}/', conf.env)
	conf.env.path_ui = utils.subst_vars('${DATADIR}/oregano/ui/', conf.env)
	conf.env.path_model = utils.subst_vars('${DATADIR}/oregano/models/', conf.env)
	conf.env.path_partslib = utils.subst_vars('${DATADIR}/oregano/library/', conf.env)
	conf.env.path_lang = utils.subst_vars('${DATADIR}/oregano/language-specs/', conf.env)
	conf.env.path_examples =  utils.subst_vars('${DATADIR}/oregano/examples/', conf.env)
#	conf.env.path_icons = '${DATADIR}/oregano/icons/'
#	conf.env.path_mime = '${DATADIR}/oregano/mime/'
#	conf.env.path_locale = '${DATADIR}/oregano/locale/'
#	conf.env.path_schemas =  utils.subst_vars('${DATADIR}/glib-2.0/schemas/', conf.env)


	#define the above paths so the application does know about files locations
	conf.define('OREGANO_UIDIR', conf.env.path_ui)
	conf.define('OREGANO_MODELDIR', conf.env.path_model)
	conf.define('OREGANO_LIBRARYDIR', conf.env.path_partslib)
	conf.define('OREGANO_LANGDIR', conf.env.path_lang)
	conf.define('OREGANO_EXAMPLEDIR', conf.env.path_examples)
#	conf.define('OREGANO_ICONDIR', conf.env.path_icons)
#	conf.define('OREGANO_MIMEDIR', conf.env.path_mime)
#	conf.define('OREGANO_LOCALEDIR', conf.env.path_locale)
#	conf.define('OREGANO_SCHEMASDIR', conf.env.path_schemas)


	conf.env.gschema_name = "io.ahoi.oregano.gschema.xml"
	conf.define('OREGANO_SCHEMA_NAME', conf.env.gschema_name)


	conf.check_cc(lib='m', uselib_store='M', mandatory=True)

	conf.check_cfg(atleast_pkgconfig_version='0.26')
	conf.check_cfg(package='glib-2.0', uselib_store='GLIB', args=['glib-2.0 >= 2.44', '--cflags', '--libs'], mandatory=True)
	conf.check_cfg(package='gobject-2.0', uselib_store='GOBJECT', args=['--cflags', '--libs'], mandatory=True)
	conf.check_cfg(package='gtk+-3.0', uselib_store='GTK3', args=['gtk+-3.0 >= 3.12', '--cflags', '--libs'], mandatory=True)
	conf.check_cfg(package='libxml-2.0', uselib_store='XML', args=['--cflags', '--libs'], mandatory=True)
	conf.check_cfg(package='goocanvas-2.0', uselib_store='GOOCANVAS', args=['--cflags', '--libs'], mandatory=True)
	conf.check_cfg(package='gtksourceview-3.0', uselib_store='GTKSOURCEVIEW3', args=['--cflags', '--libs'], mandatory=True)

	conf.check_large_file(mandatory=False)
	conf.check_endianness(mandatory=False)
	conf.check_inline(mandatory=False)

	conf.find_program('clang-format', var='CODEFORMAT', mandatory=False)
	conf.find_program('gdb', var='GDB', mandatory=False)
	conf.find_program('nemiver', var='NEMIVER', mandatory=False)
	conf.find_program('valgrind', var='VALGRIND', mandatory=False)

	# -ggdb vs -g -- http://stackoverflow.com/questions/668962
	if conf.options.build_debug:
		conf.env.CFLAGS = ['-ggdb', '-Wall']
		conf.define('DEBUG',1)
	elif conf.options.build_release:
		conf.env.CFLAGS = ['-O2', '-Wall']
		conf.define('RELEASE',1)

from waflib.Context import Context
from waflib.Build import BuildContext

def pre_fun(ctx):
	if ctx.cmd != 'install':
		logs.info ('Variant: \'' + ctx.variant + '\'')

def post_fun(ctx):
	if ctx.options.run:
		ctx.exec_command('')

def build(bld):
	bld(features='subst', source='oregano.spec.in', target='oregano.spec', install_path=None, VERSION=bld.env.version)
	if bld.variant != 'rpmspec':
		bld.add_pre_fun(pre_fun)
		bld.add_post_fun(post_fun)
		bld.recurse(rec)




class rpmspec(BuildContext):
	"""fill rpmspec"""
	cmd = 'rpmspec'
	variant = 'rpmspec'

class release(BuildContext):
	"""compile release binary"""
	cmd = 'release'
	variant = 'release'

class debug(BuildContext):
	"""compile debug binary"""
	cmd = 'debug'
	variant = 'debug'


def docs(ctx):
	logs.info("TODO: docs generation is not yet supported")


def dist(ctx):
	ctx.tar_prefix = APPNAME
	ctx.base_name = APPNAME+'-'+VERSION
	ctx.algo = 'tar.xz'
	ctx.excl = ['.*', '*~','./build','*.'+ctx.algo],
	ctx.files = ctx.path.ant_glob('src/**/*', excl=['**/*~'])
	ctx.files.extend(ctx.path.ant_glob('**/wscript'))
	ctx.files.extend(ctx.path.ant_glob('**/*', excl=['**/.*', 'build', 'buildrpm', '*.tar.*']))



def gdb_fun(ctx):
	if ctx.env.GDB:
		os.system ("G_DEBUG=resident-modules,fatal-warnings "+ctx.env.GDB[0]+" --args ./build/debug/"+APPNAME+" --debug-all")
	else:
		logs.warn ("Did not find \"gdb\". Re-configure if you installed it in the meantime.")

def nemiver_fun(ctx):
	if ctx.env.NEMIVER:
		os.system (" "+ctx.env.NEMIVER[0]+" --env=\"G_DEBUG=resident-modules,fatal-warnings\" ./build/debug/"+APPNAME+" --debug-all")
	else:
		logs.warn ("Did not find \"nemiver\". Re-configure if you installed it in the meantime.")


def valgrind_fun(ctx):
	if ctx.env.VALGRIND:
		os.system ("G_DEBUG=resident-modules,always-malloc "+ctx.env.VALGRIND[0]+" --leak-check=full --leak-resolution=high --show-reachable=no --track-origins=yes --undef-value-errors=yes --show-leak-kinds=definite --free-fill=0x77 ./build/debug/"+APPNAME+" --debug-all")
	else:
		logs.warn ("Did not find \"valgrind\". Re-configure if you installed it in the meantime.")



def massif_fun(ctx):
	if ctx.env.VALGRIND:
		os.system ("G_DEBUG=resident-modules,always-malloc "+ctx.env.MASSIF[0]+" --tool=massif --depth=10 --max-snapshots=1000 --alloc-fn=g_malloc --alloc-fn=g_realloc --alloc-fn=g_try_malloc --alloc-fn=g_malloc0 --alloc-fn=g_mem_chunk_alloc --threshold=0.01 build/debug/ ./build/debug/"+APPNAME+" --debug-all")
	else:
		logs.warn ("Did not find \"massif\". Re-configure if you installed it in the meantime.")




def codeformat_fun(ctx):
	if ctx.env.CODEFORMAT:
		nodes = ctx.path.ant_glob(\
		    ['src/*.[ch]',
		     'src/tools/*.[ch]',
		     'src/gplot/*.[ch]',
		     'src/engines/*.[ch]',
		     'src/sheet/*.[ch]',
		     'src/model/*.[ch]'])
		args = ''
		for item in nodes:
			args += str(item.abspath())+' '
		os.system (''+ctx.env.CODEFORMAT[0]+' -i '+ args)
	else:
		logs.warn ("Did not find \"clang-format\". Re-configure if you installed it in the meantime.")


def spawn_pot(ctx):
#	"create a .pot from all sources (.ui,.c,.h,.desktop)"

	ctx.recurse ('po')


def update_po(ctx):
#	"update the .po files"
	ctx.recurse ('po')

# we need to subclass BuildContext instead of Context
# in order to access ctx.env.some_variable
# TODO create a custom subclass of waflib.Context.Context which implements the load_env from BuildContext
class spawnpot(BuildContext):
	"""spawn .pot files"""
	cmd = 'spawnpot'
	fun = 'spawn_pot'

class updatepo(BuildContext):
	"""update the translate .po files"""
	cmd = 'updatepo'
	fun = 'update_po'


class codeformat(BuildContext):
	"""Format the source tree"""
	cmd = 'codeformat'
	fun = 'codeformat_fun'

class massif(BuildContext):
	"""Run with \"massif\""""
	cmd = 'massif'
	fun = 'massif_fun'

class valgrind(BuildContext):
	"""Run with \"valgrind\""""
	cmd = 'valgrind'
	fun = 'valgrind_fun'

class gdb(BuildContext):
	"""Run with \"gdb\""""
	cmd = 'gdb'
	fun = 'gdb_fun'

class nemiver(BuildContext):
	"""Run with \"nemiver\""""
	cmd = 'nemiver'
	fun = 'nemiver_fun'

def builddeps_fun(ctx):
	os.system('./builddeps.sh')

class builddeps(Context):
	"""Install build dependencies"""
	cmd = 'builddeps'
	fun = 'builddeps_fun'

def version_fun(ctx):
	with open("VERSION", "w") as f:
		f.write(VERSION + "\n")

class version(Context):
	"""Oregano Version to file VERSION"""
	cmd = 'version'
	fun = 'version_fun'

=== debian/changelog ===
oregano (0.84.40+dfsg.1-1) unstable; urgency=medium

  * New upstream release (Closes: #875473)
  * Adopt into the Debian Electronics team (Closes: #890503)
    - Changed Maintainer, Uploaders, VCS urls.
    - Thanks, Maximiliano, for maintaining it many years!
  * DH level updated to 11
  * debian/changelog: Fix some whitespaces
  * debian/control:
    - Changes related to new maintainer
    - New upstream homepage
    - New standards version 4.2.1 - no changes
    - Update some build-dependencies
      - Drop the (build-)dependency against gnome-vfs (Closes: #868401)
      - Drop the build-dependency against scrollkeeper (Closes: #885614)
      - Added python since now built using 'waf'
  * debian/copyright:
    - HTTPS URL for Format field
    - Exclude a few model files with slightly troublesome licenses.
  * debian/gbp.conf: Added to enforce pristine-tar
  * debian/patches:
    - Refreshed patches and deleted outdated ones
    - New patch: 0003-Remove-Encoding-field-in-desktop-file.patch
    - New patch: debian/patches/0004-Spelling-fixes.patch
  * debian/README.source: Describe why the tarball is repacked
  * debian/repack-waf:
    - New script used by uscan/watch to repack tarball without
      binary 'waf'.
  * debian/rules:
    - Delete gschemas.compiled in install
    - Properly clean up in dh_clean
    - Update to call 'waf' to build the package
  * debian/watch:
    - Call debian/repack-waf
    - Mangle version adding +dfsg
    - New upstream URL

 -- Ruben Undheim <rubund@debian.org>  Sat, 13 Oct 2018 13:05:56 +0200

=== debian/control ===
Source: oregano
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Ruben Undheim <rubund@debian.org>
Build-Depends: debhelper (>= 11),
               intltool,
               libcairo2-dev,
               libfontconfig1-dev,
               libfreetype6-dev (>= 2.1.0),
               libgtk-3-dev,
               libgoocanvas-2.0-dev,
               libgtksourceview-3.0-dev,
               libpng-dev,
               libx11-dev,
               libxml2-dev,
               libxrender-dev (>= 0.6.0),
               python
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/electronics-team/oregano
Vcs-Git: https://salsa.debian.org/electronics-team/oregano.git
Homepage: https://github.com/drahnr/oregano

Package: oregano
Architecture: any
Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
Recommends: gnucap
Description: tool for schematical capture of electronic circuits
 Oregano is a GNOME application for schematic capture and printing of
 electronic circuits. It can simulate the circuits using Gnucap,
 ng-spice or Berkeley spice.

## oregano 0.84.41%2Bdfsg.1

=== src/wscript ===
#! /usr/bin/env python3
# encoding: utf-8

import os
from waflib import Logs as logs
from waflib import Utils as utils

def options(opt):
	pass

def configure(conf):
	pass

def build(bld):
	if bld.cmd == 'install' or bld.cmd == 'uninstall':
		if not os.geteuid()==0:
			logs.warn ('You most likely need root privileges to install or uninstall properly.')


	nodes =  bld.path.ant_glob(\
	    ['*.c',
	     'tools/*.c',
	     'gplot/*.c',
	     'engines/*.c',
	     'sheet/*.c',
	     'model/*.c'],
	     excl='main.c')

	bld.objects (
		['c','glib2'],
		source = nodes,
		includes = ['.', 'tools/', 'engines/', 'gplot/', 'model/', 'sheet/'],
		uselib = 'M XML GOBJECT GLIB GTK3 XML GOOCANVAS GTKSOURCEVIEW3',
		target = 'shared_objects'
	)

	exe = bld.program(
		features = ['c', 'glib2'],
		target = bld.env.appname,
		source = ['main.c'],
		includes = ['.', 'tools/', 'engines/', 'gplot/', 'model/', 'sheet/'],
		use = 'shared_objects',
		uselib = 'M XML GOBJECT GLIB GTK3 XML GOOCANVAS GTKSOURCEVIEW3',
		settings_schema_files = ['../data/settings/'+bld.env.gschema_name ] if not bld.options.no_install_gschema else [],
		install_path = "${BINDIR}"
	)

	for item in exe.includes:
		logs.debug(item)

## oregano 0.84.41+dfsg.1

=== wscript ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #! /usr/bin/env python3
 # encoding: utf-8
 
-VERSION = '0.84.40'
+VERSION = '0.84.41'
 APPNAME = 'oregano'
 
 top = '.'

=== data/wscript ===
#! /usr/bin/env python
# encoding: utf-8

top = '..'
out = '../build'

from waflib import Logs as logs
from waflib import Utils as utils


def options(opts):
	pass


def configure(conf):
	pass


def build(bld):
	if bld.cmd == 'install':
		#intl does not like the keys in (not an xml and no translation strings)
		#add to potfiles in for another try
		bld.install_as ('${DATADIR}/mime-info/oregano.keys', 'mime/oregano.keys.in')
		bld.install_files ('${DATADIR}/icons/hicolor/48x48/apps/', 'mime/oregano.png')
		bld.install_files ('${DATADIR}/icons/hicolor/scalable/apps/', 'mime/oregano.svg')
		bld.install_files ('${DATADIR}/oregano/ui/', 'xml/splash.xpm')
		#things we need to be known by the app are already defined and stored in the main wscript
		bld.install_files (bld.env.path_lang, 'netlist.lang')
		bld.install_files (bld.env.path_model, bld.path.ant_glob('models/*.model'))
		bld.install_files (bld.env.path_datadir, bld.path.ant_glob('help/**/*'), cwd=bld.path, relative_trick=True)
		bld.install_files (bld.env.path_examples, bld.path.ant_glob('examples/*.oregano'))
		bld.install_files (bld.env.path_partslib, bld.path.ant_glob('libraries/*.oreglib'))
		bld.install_files (bld.env.path_ui, bld.path.ant_glob('xml/*.ui'))

		if not bld.options.no_xdg:
			try:
				bld.exec_command(['update-desktop-database', utils.subst_vars('${DATADIR}/applications', bld.env)])
			except:
				logs.warn('Failed to execute xdg desktop database update.')

			try:
				bld.exec_command(['update-mime-database', utils.subst_vars('${DATADIR}/mime', bld.env)])
			except:
				logs.warn('Failed to execute xdg mime database update.')

	bld(
		features  = 'intltool_in',
		podir     = "../po",
		style     = "desktop",
		source    = 'oregano.desktop.in',
		target    = 'oregano.desktop',
		install_path = '${DATADIR}/applications',
	)

	bld(
		features  = 'intltool_in',
		podir     = "../po",
		style     = "schemas",
		source    = 'settings/io.ahoi.oregano.gschema.xml',
	)

	bld(
		features  = 'intltool_in',
		podir     = "../po",
		style     = "xml",
		source    = 'mime/oregano-mimetypes.xml.in',
		target    = 'mime/oregano.xml',
		install_path = '${DATADIR}/mime/packages/',
	)


	bld(rule = "nroff -man -c ${SRC} > ${TGT}", source="oregano.MAN.in", target="oregano.1")
	bld.install_files ('${MANDIR}/man1', 'oregano.1')

=== po/wscript ===
#! /usr/bin/env python
# encoding: utf-8

top = '..'
build = '../build'

from waflib import Logs as logs

def spawn_pot(ctx):
	"""
	Create the initial pot file containing strings to translate.
	"""
####################################################################################################
####################################################################################################
####################################################################################################
	def spawn_pot_run_stage1(task):
		srcs = task.inputs
		tgt = task.outputs[0]

		node = tgt.get_bld()
		for src in srcs:

#	this would work pretty well if intltool-update would not prefix another "../" - retarded
#	so now we go for hardcoding build/po and thus just prefixing another "../" for the source path and we are done"
			a = src.parent.get_bld() # cut off the filename, 
			a = task.generator.bld.path
			b = src.get_src()
			src = b.path_from(a)
			
			if str(src).endswith(".ui"):
				node.write("[type: gettext/glade]../{0}\n".format(src), 'a')
			elif str(src).endswith(".gschema.xml") or str(src).endswith(".gschema.xml.in"):
				node.write("[type: gettext/gsettings]../{0}\n".format(src), 'a')
			elif str(src).endswith(".in"):
				node.write("../{0}\n".format(src), 'a')
		return 0


	# gen a list of all ui and translateable files alias *.in
	nodes = []
	nodes.extend(ctx.path.parent.ant_glob('**/*.in', excl=['*POTFILES*','*potfiles*','**/po/**', '**/*spec.in']))
	nodes.extend(ctx.path.parent.ant_glob('**/*.ui'))
	ctx(rule = spawn_pot_run_stage1,
		name = "spawnpot - enlist",
		source = nodes,
		target = 'POTFILES.in')
####################################################################################################
####################################################################################################
####################################################################################################

### FIXME FIXME FIXME this pollutes the source directory! copy all nodes from "nodes" to the bld subdir and let intltool-update work from there
### FIXME FIXME FIXME this also would get rid of the hack reequireing a another "../" prefix

	def spawn_pot_run_stage2(task):
		
		srcs = task.inputs[0]
		tgt = task.outputs
		import os
		ret = task.exec_command('pwd; cd po; pwd; intltool-update --headers; cd ..; pwd')
		return ret

	# gen .h files for all non source files
	target_nodes = [str(node) + '.h' for node in nodes]
	ctx(rule=spawn_pot_run_stage2,
		name = "spawnpot - generate headers",
		source = 'POTFILES.in')
#		,
#		target = target_nodes)

####################################################################################################
####################################################################################################
####################################################################################################

#	def spawn_pot_run_stage3(task):
#		srcs = task.inputs
#		tgt = task.outputs[0]

#		node = tgt.get_bld()
#		print ("target3 {0} {1}".format(len(srcs),str(node.abspath())))
#		for src in srcs:
##	this would work pretty well if intltool-update would not prefix another "../" - retarded
##	so now we go for hardcoding build/po and thus just prefixing another "../" for the source path and we are done"
#			a = src.parent.get_bld() # cut off the filename, 
#			a = task.generator.bld.srcpath
#			b = src.get_src()
#			src = b.path_from(a)
#			src = src.srcpath
#			print ("tgt xx {0}".format(src) )
#			node.write("{0}".format(src), 'a')
#		return 0

#	# seek for all header and source files to translate and enlist them
#	totranslate = []
#	totranslate.extend(ctx.path.parent.ant_glob('**/*.c', excl=['test/*.c']))
#	totranslate.extend(ctx.path.parent.ant_glob('**/*.h', excl=['test/*.h']))
#	ctx(rule = spawn_pot_run_stage3,
#		name = "spawnpot - collect",
#		source = totranslate,
#		target = 'potfiles.in',
#		after = "spawnpot - generate headers")

	# extract translateable strings from all c/h/generated h files
#	ctx(rule = 'xgettext -k_ -kN_ -E -f ./${SRC} --package-name='+ctx.env.appname+' --package-version '+ctx.env.version+' -o ${TGT}',
#		name = "spawnpot - generate .pot",
#		source = 'potfiles.in',
#		target = ctx.env.appname+'.pot')



def update_po(ctx):
	"""
	Does not work yet.
	"""
	nodes = ctx.path.ant_glob('../build**.po')
	for node in nodes:
		ctx(rule = 'msgmerge -U "${SRC}" "${TGT}"',
			source = node,
			target = node)


def options(opts):
	pass


def configure(conf):
	pass


def build(bld):

	bld(
		features='intltool_po',
		appname=bld.env.appname,
		podir='.',
		install_path="${LOCALEDIR}")

=== test/wscript ===
#! /usr/bin/env python3
# encoding: utf-8

def options(opt):
	pass

def configure(conf):
	pass

def build(bld):
	bld.program(
		features = ['c', 'glib2'],
		target = 'microtests',
		source = ['test.c'],
		includes = ['.', '../src', '../src/tools/', '../src/engines/', '../src/gplot/', '../src/model/', '../src/sheet/'],
		use = 'shared_objects',
		uselib = 'M XML GOBJECT GLIB GTK3 XML GOOCANVAS GTKSOURCEVIEW3'
	)

=== debian/changelog ===
oregano (0.84.41+dfsg.1-1) unstable; urgency=medium

  * New upstream release
  * debian/control:
    - Build-depend on python3 instead of python2
    - New standards version 4.3.0 - no changes
  * debian/repack-waf:
    - Fixes since waf filename has changed

 -- Ruben Undheim <rubund@debian.org>  Tue, 29 Jan 2019 15:36:16 +0000

=== debian/control ===
--- 
+++ 
@@ -15,8 +15,8 @@
                libx11-dev,
                libxml2-dev,
                libxrender-dev (>= 0.6.0),
-               python
-Standards-Version: 4.2.1
+               python3
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/electronics-team/oregano
 Vcs-Git: https://salsa.debian.org/electronics-team/oregano.git
 Homepage: https://github.com/drahnr/oregano

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all


LDFLAGS += -lcairo

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	./waf configure --debug --prefix=/usr

override_dh_auto_build:
	./waf build --debug --prefix=/usr

override_dh_auto_install:
	./waf install --destdir=debian/oregano --prefix=/usr
	$(RM) debian/oregano/usr/share/glib-2.0/schemas/gschemas.compiled

override_dh_clean:
	dh_clean
	find waflib/ -name "*.pyc" -delete
	$(RM) .lock-waf_linux2_build
	$(RM) -r build
